import java.awt.*;

public class DrawingCanvas
    extends Canvas
{

private Painter painter; // a reference to the painter that paints into the DrawingCanvas

public void add(Painter painter) // registers the painter sets that painters DrawingCanvas
{
    this.painter = painter;
    painter.setDrawingCanvas(this);
};

public void paint(Graphics g) // call the painter's draw method and hand over the Graphics-Object
{
    painter.draw(g);
    
    // Note: Drawing into a Canvas (or another Component) can only take place in the paint method of this Canvas.
    //       If the drawing code is in another method (maybe in another class) you have to call that method with
    //       the Graphics-Object as a parameter.
    
};

};
